/* COMP 211, Lab 12
 *
 * Trees and searching
 */

#include <stdbool.h>

/*
 * Structs for binary btree
 */
typedef struct bnode {
    int key;
    struct bnode *left;
    struct bnode *right;
} bnode;

typedef struct btree {
    bnode *root;
} btree;

/*
 * Create an empty binary btree
 */
btree* empty();

/*
 * Insert node
 */
void insert(btree*, int);

/*
 * Iterative search
 */
bool search(btree*, int);

/*
 * Recursive search
 */
bool searchr(bnode*, int);

/*
 * Inorder traversal: recursive
 */
void inorder(bnode*);

/*
 * Preorder traversal: recursive
 */
void preorder(bnode*);

/*
 * Postorder traversal: recursive
 */
void postorder(bnode*);

/*
 * Display tree contents inorder
 */
void print_inorder(btree*);

/*
 * Display tree contents preorder
 */
void print_preorder(btree*);

/*
 * Display tree contents postorder
 */
void print_postorder(btree*);
